//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

// C Header File
// Created 08/09/02; 17:03:30

//---------------------------------------------------------------------------

#define BOARD_WIDTH (12)
#define BOARD_HEIGHT (12)
#define CONNECT_MAX (10)
#define STATS_LEFT (100)

//---------------------------------------------------------------------------

enum {TG_PLAYING,TG_WIN,TG_EXAEQUO};
enum {TT_NONE,TT_PLAYER1,TT_PLAYER2};

//-----------------------------------------------------------------------------

typedef struct
{
int x,y;
}
TPoint;

typedef struct
{
char Matrix[BOARD_WIDTH][BOARD_HEIGHT];
int turn;
int state;
}
TBoard;

typedef struct
{
TPoint History[BOARD_WIDTH*BOARD_HEIGHT];
int step;
int step_max;
}
THistory;

typedef struct
{
TBoard Board;
THistory History;
TPoint CursorPos;
TPoint Dim;
int length_to_connect;
int fall_mode;
}
TGame;


//-----------------------------------------------------------------------------

void NewGame(void);
void RefreshScreen(void);
void Play(TPoint Point);
int CanMakeMove(TPoint Position);
int Has_Won(TPoint Position);
void Undo(void);
void Redo(void);
void PlayRandomPos(void);

//-----------------------------------------------------------------------------
